#include        "ksysdefs.h"
#include        "ksysvtyp.h"
#include        "ksysprot.h"
#include        "ksyskord.h"
findsort(is)
char	*is;
{
	auto	int		ret;
	auto	int		psc;
	auto	char	ps[BLKSIZ];
	auto	char	*psx;
	auto	char	ws[BLKSIZ];
	auto	char	*pfx;
/**/
	ret = access(is,01);
	if(!ret)	{
		pfx = biblsort;
		biblsort = strsave(is);
		free_if(pfx);
		return(ret);	/* found exact name */
		}
/**/
	if(!(psx = kgetenv("PATH")))	{
		errmsg("findsort <no PATH>\n");
		return(1);
		}
/**/
	strcpy(ps,psx);
	strxty(ps,'\\','/');
	psx = ps;
/**/
	if(kenv.dosdos)	psc = ';';
	else			psc = ':';
/**/
	while(psx = xgnc(ws,ws+FNMSIZ-1,psx,psc))	{
/**/
		if(strlen(ws)) 	strcat(ws,"/");
		else			strcat(ws,"./");
		strcat(ws,is);
/**/
		if(access(ws,01) == 0)	{
			pfx = biblsort;
			biblsort = strsave(ws);
			free_if(pfx);
			return(0);
			}
		}
/**/
	errmsg("findsort <cannot find sort> '%s'\n",is);
/**/
	return(1);
}
char    *
zart(is)        /* remove English articles */
char    *is;
{
/*
        will fail if all caps
*/
        if(*is == 'T' &&
            *(is+1) == 'h' &&
                *(is+2) == 'e' &&
                    *(is+3) == ' ') strcpy(is,is+4);
        else
        if(*is == 'A' &&
            *(is+1) == ' ')         strcpy(is,is+2);
        else
        if(*is == 'A' &&
            *(is+1) == 'n' &&
                *(is+2) == ' ')     strcpy(is,is+3);
        return(is);
}
char    *
setcmd(os,is)
char    *os;
char    *is;
{
        strcnd(is);
        if(*is != '!')  {
            errmsg("<bad syntax> [%s]\n",is);
            terror(FUBAR);
            }
        return(strcpy(os,is));
}
newkeys(is)
char    *is;
{
/**/
    if(isnull(is))  keyslist(stdout);
	else			keysread(keysfile(is));
/**/
    return(ZERO);
}
newdir(os)
char    *os;
{
	if(kchdir(os))	terror(FUBAR);
	return(ZERO);
}
othercmd(os,us)
char    *os;
char    *us;
{
    if(strncmp(os,"cd",2) == 0) return(newdir(os+2),1);
    else
    if(strncmp(os,"sh",2) == 0) return(system("sh"),1);
    else
    if(strncmp(os,"so",2) == 0) return(doso(os+2,us),1);
    else                        return(0);
}
badcard(is,fp,cn,da)   	/* check if real eof or simply bad card */
char	*is;			/* file name */
FILE	*fp;			/* file pointer */
NOSIGN	cn;				/* card number */
long	da;				/* card address */
{
    auto    char    *err = rderr(NULL);
	auto	char	*dab = "<bad key> '%s' at %u in %s\n";
    if(err) {
		errmsg(dab,err,cn,is);
		efseek(fp,da,0);
		xrdcd(kb.base,kb.bmax,fp);
		xwrcdf(kb.base,stderr,kenv.folder,NULL);
		errmsg(dab,err,cn,is);
        terror(FUBAR);
        }
    return(0);
}
void
showfile(ty,is)
NOSIGN    ty;
char    *is;
{
    auto    char    ws[FNMSIZ];
    auto    long    siz;
    auto    char    *mod;
	strcnd(is);
    while((int)(is = xgnc(ws,ws+FNMSIZ-1,is,' '))) {
        siz = filesize(ws);
        if(siz >= 0L)   mod = filemod(ws);
        else            mod = "<new file>";
        printf("%c %14s %8ld %s\n",ty,mod,siz,ws);
    }
    fflush(stdout);
}
void
filelist(is)        /* list files and other specifications */
char    *is;        /* diagnostic trace */
{
    auto    char        *fmt = NULL;
    auto    int         i = 0;
    if(!kenv.prompt)    return;
    scr_cl(stdout);
    if(!isnull(is)) printff("%s",is);
/**/
	printff("Blocking: %u\n",kenv.blockd);
/**/
    fmt = "No Diagnostics\n";
    if(kenv.diagno) fmt = "Diagnostics %d\n";
    printff(fmt,kenv.diagno);
/**/
    fmt = "No Uniq\n";
    if(uniq)    fmt = "Uniq On: Beware\n";
    printff(fmt);
/**/
    fmt = "No a! filter\n";
    if(!isnull(acmd))   fmt = "a!%s\n";
    printff(fmt,acmd);
    fmt = "No b! filter\n";
    if(!isnull(bcmd))   fmt = "b!%s\n";
    printff(fmt,acmd);
/**/
    fmt = "No Join\n";
    if(join)            fmt = "Join = %c\n";
    printff(fmt,join);
/**/
    fmt = "No Sorts\n";
    if(nsorts)          fmt = "Sorts (%d)\n";
    printff(fmt,nsorts);
    for(i = 0; i < nsorts; i++)
    printff("s%s\n",ksx[i].rc);
/**/
    if(isnull(efn)) fmt = "No Script File List\n";
    else            fmt = "Script File\n";
    printff(fmt,efn);
    showfile('S',efn);
/**/
    if(isnull(ifn)) fmt = "No Input File(s) List\n";
    else            fmt = "Input File(s) List\n";
    printff(fmt);
    showfile('I',ifn);
/**/
    if(isnull(ofn) || *ofn == '-')  {
        fmt = "Output to stdout (Terminal)\n";
        printff(fmt);
        }
    else    {
        fmt = "Output File Will Not Overwrite\n";
        if(over == '!')
            fmt = "Output File Will Overwrite\n";
        printff(fmt);
        }
    showfile('O',ofn);
/**/
	printff("Keys File: %s\n",keysget());
	printff("Sort Program: %s\n",biblsort);
	printff("Temporary Directory: %s\n",tmpdir);
	if(kenv.dosdos)
	printff("Switch Character: %c\n",switchar(0));
}
void
setifn(is)            /* interactive input file list */
char	*is;
{
    ifn = free_if(ifn);
    ifn = fexpand(is);
}
void
setofn(os,us)     /* output file 'list' */
char    *os;
char    *us;
{
    over = ' ';
/**/
    switch(*os) {
    case    '!':
    case    'O':
    case    'W':    over = '!';
                    os += 1;
                    break;
    case    'w':
    case    'o':    setofn(os+1,us);
                    return;
    }
/**/
    strcnd(os);
/**/
    if(isnull(os))  ofn = free_if(ofn);
    else            ofn = fexpand(os);
/**/
    return;
}
void
listing(is)     /* display a card file */
char    *is;    /* list of file names */
{
    auto    FILE    *lfp = NULL;
    auto    char    ws[FNMSIZ];
    auto    int 	cnt = 0;
	auto	int		loop = 1;
/**/
    while(loop &&(int) (is = xgnc(ws,ws+FNMSIZ-1,is,' ')))     {
        if(lfp) lfp = xfclose(lfp);
        lfp = tefopen(ws,"r");
        while(clcd(),rdcd(lfp,'v')) {
            cnt += 1;
            if(kenv.leisur & DA)            scr_cl(stdout);
            twrcd(stdout,'f',kenv.folder);
            if(kenv.leisur & DB)    {
                if(query(stdout) == 'q')    {
					loop = 0;
					xfclose(lfp);
					lfp = NULL;
					break;
					}
                }
            }
    }
/**/
    if(rderr(NULL)) badcard(ws,lfp,cnt,ftell(lfp));
/**/
    lfp = xfclose(lfp);
/**/
}
badcmd(is)
char    *is;
{
    errmsg("<failed> '%s'\n",is);
    terror(FUBAR);
    return(0);
}
void
cleanup()
{
    if(access(wfn,0) == 0)      unlink(wfn);
    if(access(sfn,0) == 0)      unlink(sfn);
}
touch(is)		/* create zero length work files */
char	*is;
{
	auto	FILE	*tfp;
	tfp = tefopen(is,"w");
	xfclose(tfp);
	return(ZERO);
}
void
doexpr(is)
char    *is;
{
    auto    char    ws[BLKSIZ];
    auto    char    *wsu = ws + BLKSIZ - 1;
    while((int)(is = xgnc(ws,wsu,is,'|')))    parsecmd(ws,wsu);
}
void
outlist(argc,argv)  /* set ouput from cmd line */
int     argc;
char    *argv[];
{
	ofn = NULL;
    if(cmdnum(argc,argv,'o',0,1))   {
        ofn = cmdstr(argc,argv,'o',NULL);
        over = ' ';
        }
    else
    if(cmdnum(argc,argv,'O',0,1))   {
        ofn = cmdstr(argc,argv,'O',NULL);
        over = '!';
        }
}
void
setefn(is)
char	*is;
{
	strcnd(is);
	if(isnull(is))	{
		if(isnull(efn))	{
			errmsg("<no previous script file>\n");
			terror(FUBAR);
			}
		}
	else	{
        efn = free_if(efn);
        efn = fexpand(is);
		}
	return;
}
void
xso(os)      	/* edit a script file */
char    *os;
{
    auto    char    ws[FNMSIZ];
/**/
    strcpy(ws,"vi +1 %");
/**/
	setefn(os);
/**/
    doshell(ws,efn,NULL);
/**/
}
void
doso(os,us)     /* get a script file */
char    *os;
char    *us;
{
    auto    FILE    *fp;
/**/
	setefn(os);
/**/
    fp = tefopen(efn,"r");
/**/
    tgetcmd(os,us,fp);
    xfclose(fp);
}
cansort()   /* check for preconditions */
{
    auto    int     reb = YES;
    auto    FILE    *fp;
    if(nsorts <= 0) {
        errmsg("<no sorts>\n");
        terror(FUBAR);
        }
/**/
    if(isnull(ifn)) {
        errmsg("<no input file(s)>\n");
        terror(FUBAR);
        }
/**/
	if(canread(ifn))	terror(FUBAR);
/**/
    if(isnull(ofn) || strcmp(ofn,"-") == 0) {
        reb = 0;
        }
    else    {
        if(filesize(ofn) >= 1L) {
            if(over == ' ') {
                errmsg("<to overwrite use> o!%s\n",ofn);
                terror(FUBAR);
                }
            }
/*		check for write permission on output file */
        fp = efopen(ofn,"a");
        xfclose(fp);
        }
    over = ' '; /* latch to prevent overwrites */
    return(reb);
}
void
rcmdlist(argc,argv)     /* input file list from the command line */
int     argc;
char    *argv[];
{
    ifn = cmdlist(argc,argv,ZERO,NULL);
}
/**/
